Subject: Re: [net-next: PATCH v3 5/6] net: mvpp2: enable using phylink with ACPI

From: Andrew Lunn <[email-masked]>
Date: Thu, 24 Jun 2021 03:17:50 +0200

On Wed, Jun 23, 2021 at 11:45:04PM +0200, Marcin Wojtas wrote:
> Hi,
> 
> śr., 23 cze 2021 o 22:37 Andrew Lunn <[email-masked]> napisał(a):
> >
> > > +static bool mvpp2_use_acpi_compat_mode(struct fwnode_handle *port_fwnode)
> > > +{
> > > +     if (!is_acpi_node(port_fwnode))
> > > +             return false;
> > > +
> > > +     return (!fwnode_property_present(port_fwnode, "phy-handle") &&
> > > +             !fwnode_property_present(port_fwnode, "managed") &&
> > > +             !fwnode_get_named_child_node(port_fwnode, "fixed-link"));
> >
> > I'm not too sure about this last one. You only use fixed-link when
> > connecting to an Ethernet switch. I doubt anybody will try ACPI and a
> > switch. It has been agreed, ACPI is for simple hardware, and you need
> > to use DT for advanced hardware configurations.
> >
> > What is your use case for fixed-link?
> >
> 
> Regardless of the "simple hardware" definition or whether DSA + ACPI
> feasibility, you can still have e.g. the switch left in "unmanaged"
> mode (or whatever the firmware configures), connected via fixed-link
> to the MAC. The same effect as booting with DT, but not loading the
> DSA/switch driver - the "CPU port" can be used as a normal netdev
> interface.

You can do this, but i would not recommend it. Without having STP,
your network is going to be vulnerable to broadcast storms killing
your network.

> I'd also prefer to have all 3 major interface types supported in
> phylink, explicitly checked in the driver - it has not been supported
> yet, but can be in the future, so let's have them covered in the
> backward compatibility check.

Maybe i'm not understanding this correctly, but isn't this condition
enforcing there must be a fixed link in order to use the new ACPI
binding? But i expect most boards never need a fixed-link, it is
optional after all.

	 Andrew